const getAllWorkflows = async (query = {}) => {
    const workflows = await bpmsDB.bpms_workflow.findAll({
        where: {
            // id:workflowId,
            deletedAt: {
                [Op.is]: null
            },
            version: {
                [Op.gt]: 0
            },
            ...query
        },
        raw: true
    })
    return workflows;
}

module.exports = {
    getAllWorkflows,

}